/* hashstats: to get some insight into hash-table collisions 
 * Array of Linked Lists works here because the latter is non-generic
 */

import java.util.*;

class hashStats {
    //public lister () {}

    //============================================================

    public static void main(String[] args) {

	String[] A = {
	    "avocado",
	    "banana",
	    "canteloupe",
	    "durian",
	    "eggplant",
	    "feijoa",
	    "guava",
	    "hackberry",
	    "iceberg",
	    "jicama",
	    "kale",
	    "lime",
	    "mango",
	    "persimmon",
	    "quince",
	    "rutabega",
	    "spinach",
	    "tangerine",
	};


	List<String> slist = new ArrayList<String>();
	//for (int i = 0; i<A.Length; i++) slist.Add(A[i]);
	for (int i = 0; i<FV.length; i++) slist.add(FV[i]);
	//System.out.println(slist.Count);

	System.out.println("length of FV is " + FV.length);

	if (args.length >= 1) htablesize = new Integer(args[0]);
	htable = new Cell[htablesize];
	for (int i = 0; i<htablesize; i++) htable[i] = null;

	for (String veg : slist) {
		System.out.format("%s: %d%n", veg, hash(veg));
		int h = hash(veg);
		htable[h] = new Cell(veg, htable[h]);
	}

	System.out.println("Table size: " + htablesize);

	for (int i = 0; i< htablesize; i++) {
	   Cell p = htable[i];
	   int count = 0;
	   while (p!= null) {count++; p = p.next();}
	   if (count !=0) System.out.format("htable[%d]: length %d%n", i, count);
	}

	/*
 	for (int ht = 20; ht<100; ht++) {
		System.out.println("calling run() with size {0}", ht);
		run(ht, slist);
	}
	/* */
    }

    static int htablesize = 101;
    static Cell[] htable; 

    public static int hash(String s) {
	return hash(s, htablesize);
    }

    public static int hash(String s, int htsize) {
	int h = s.hashCode() % htsize;
	if (h<0) h+= htsize;	// stupid negative numbers
	return h;
    }

    public static class Cell {
    	private String s_;
    	private Cell  next_;
    	public Cell(String s, Cell n) {s_ = s; next_ = n;}
    	public String getString() {return s_;}
    	public Cell   next() {return next_;}
            public void setString(String s) {s_ = s;}
            public void setNext(Cell c)   {next_ = c;}
        }

    public static void run(int htsize, List<String> slist) {
    	htable = new Cell[htsize];
    	for (int i = 0; i<htsize; i++) htable[i] = null;

    	for  (String veg : slist) {
    		//System.out.println("{0}: {1}", veg, hash(veg));
    		int h = hash(veg, htsize);
    		htable[h] = new Cell(veg, htable[h]);
    	}

    	System.out.println("Table size: " + htsize);

    	for (int i = 0; i< htsize; i++) {
    	   Cell p = htable[i];
    	   int count = 0;
    	   while (p!= null) {count++; p = p.next();}
    	   if (count > 1) System.out.format("htable[%d]: length %d%n", i, count);
    	}
    }
	
    public static String[] FV = {
	"artichoke", "arugula", "asparagus", "amaranth", "alfalfa_sprouts", "adzuki_beans",
	"black_beans", "black_eyed_peas", "broccoli", "brussels_sprouts", "beet",
	"cabbage", "celery", "chickpeas", "carrots", "cherries", "corn", "coconut", "chard",
	"daikon", "durian", "date", "dragonfruit", "damson_plum",
	"eggplant", "endive", "elderberry",
	"figs", "fiddleheads", "feijoa", 
	"guava", "grape", "grapefruit", "gooseberry", "garlic", "ginger", "green_beans",
	"hackberry", "herbs", "huckleberry", "honeydew",
	"iceberg", 
	"jicama", "jerusalem_artichoke", "juniper_berry", "jackfruit",
	"kale", "kohlrabi", "kiwi", "kumquat", "kiwano",
	"lettuce", "lemon", "lime", "lingonberry", "leek", "loquat", "lychee",
	"mango", "maize", "mushroom", "melon",
	"nectarine", "ngombo", "nuts",
	"onion", "okra", "olive", "orange",
	"papaya", "parsley", "peach", "pepper", "parsnip", "potato", "pea", "pear", "persimmon", "pumpkin",
	"quince",
	"radish", "radicchio", "rhubarb", "raspberry", "rutabega",
	"salsify", "spinach", "sorrel", "squash", "strawberry", "starfruit",
	"tomato", "taro", "tamarind",
	"ugli",
	"watercress", "watermelon", "water_chestnut",
	"yam",
	"zuchhini"
    };
}

